#!/bin/sh
#
# Purpose:
#	moves late objects when it find a moveto flag
#
# Synopsis:
#	moveLateObjects.sh <file> <old_studyUID>
#
# Arguments:
#	file:	the late object
#	old_studyUID:	before the study moved the object belong to this study
#
# Description:
#	First validate the moveto.{old_study_UID} flag file. It has to contain the NewStudyUID,
#	UIDFile, ModFile. Creates a workdirectory. Call CopyDicomFiles on file and move the new 
#	file to it's correct place ($REPOSITORY_DICOM_DATA/xx/yy/zz/$NewStudyUID) and call storescp_reg.sh
#
# OBSOLETE: use cases.MoveLateObject instead
#

File=$1
Study=$2

[ -z "$File" ] && exit 1;
[ -z "$Study" ] && exit 1;

[ -z "$IMAGE_TMP" ] && . $HOME/etc/setenv.sh

LOGGER="/usr/bin/logger"
TAG="movelateobjects[$$]"

$LOGGER -p $LOG_FACILITY.debug -t "$TAG" "ARGS: $@"

run_()
{
	$TASKD_HOME/runjavacmd -c "0 ${CASES_HOME#$HOME/component/}.MoveLateObject -L -f \"${File}\" -s \"${Study}\"" -p $JAVA_SERVER_PORT
	ERR=$?
	exit $ERR
} #run_()

#
# default get resources 
#
get_resources_()
{
	echo "System.DISK"
}


#
# default get display name (for subjob)
#
get_display_name_()
{
	echo "Move late objects received for a merged/split study to result study"
}

get_property_() {
	if [ "$PROPERTY" = "1PST" -a -n "$Study" ] ; then
		echo -n "$Study"
	else
		get_def_property_
	fi
}
