#
# Description:
#  Wrapper script around Xvfb. If Xvfb dies it will be restarted.
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$

. $HOME/etc/setenv.sh

# stop if running
if [ -f "$XVFB_RUN" ] ; then
	#echo "Xvfb seems to be running"
	rm "$XVFB_RUN"
	PID=`cat ${XVFB_PID}|grep '[0-9]\+'`
	rm "$XVFB_PID" 2>/dev/null
	if [ ! "$PID" == "" ]; then
		# Does the pid exist and it's Xvfb?
		if ps axcw|awk -v "pid=$PID" \
				'BEGIN { v = 1; }
				$1==pid && $5 ~ "[X]vfb" { v = 0; }
				END { exit v; }'; then
			# Yes, it is, kill it.
			kill "$PID"
			# wait for the wrapper to exit
			sleep 1
			echo "Xvfb stopped"
		fi																		 
	fi																				 
	unset PID
fi

[ "$1" == "stop" ] && exit 0;

if [ "`which Xvfb`" == "" ]; then
	echo "Xvfb not found, exiting."
	exit 0;
fi

touch $XVFB_RUN

# turn on monitoring, needed for job controls
set -m

while true; do

	#echo Xvfb $XVFB_DISPLAY 
	Xvfb $XVFB_DISPLAY -ac &
	PID=$!
	echo "$PID" >$XVFB_PID
	fg

	if [ ! -f "$XVFB_RUN" ] ; then
		echo `date` "Wrapper: Xvfb normal shutdown"
		exit 0;
	fi

	echo `date` "Wrapper: Xvfb abnormal termination"
	# Add Watson error

	$DRWATSON_HOME/addmessage.sh -t ERROR -l NONE "restarting Xvfb"

	echo `date` "Wrapper: Restarting Xvfb"
done
