#!/bin/sh
#

. ~/etc/setenv.sh

LOGGER="/usr/bin/logger"
TAG="getiso[$$]"

$LOGGER -p $LOG_FACILITY.debug -t "$TAG" "PATH_INFO: $PATH_INFO"


filename=""
filetype=""
id=""
fullpath=""


filename=${PATH_INFO#/cd};
if [ "${filename%.iso}" != "${filename}" ] ; then
	filetype="ISO"
	id=${filename%.iso}
	fullpath="$TMP/mediasession/mediasession_$id/cdimage.iso"
	echo "Content-type: application/x-iso-image"
	$LOGGER -p $LOG_FACILITY.debug -t "$TAG" "full path: $fullpath"

elif [ "${filename%.zip}" != "${filename}" ] ; then
	filetype="ZIP"
	id=${filename%.zip}
	fullpath="$TMP/mediasession/mediasession_$id/media.zip"
	echo "Content-type: application/x-zip"
	$LOGGER -p $LOG_FACILITY.debug -t "$TAG" "full path: $fullpath"

else
	echo "Content-type: text/plain"
	echo
	echo "File not found..."
	$LOGGER -p $LOG_FACILITY.debug -t "$TAG" "File not found"
	return 1

fi

size=`ls -l $fullpath | awk '{ print $5 } '`;

echo "Content-length: $size"
echo

cat $fullpath
