<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: dotcom
 *
 * Description:
 *    Moves study from one HUB server to another one
 *
 *
 *  @param cStudy                  Study Instance UID of the study to be moved
 *  @param cTarget                 Device ID of the HUB server the study to be moved to
 *  @param cOp                     Do the move if value is 'move', give a confirmation page otherwise
 * [@param cBack      Back url]
 * [@param cSession   Session id for caching study information collected from the HUB servers]
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@
	page import="java.io.*, java.util.*, imagemed.exception.*, imagemed.imsession.*, imagemed.jsputil.*,
			imagemed.util.*, imagemed.dotcom.*, imagemed.dotcom.multihub.*, imagemed.types.string.IMTypePN"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!

	/** Tab page (display page under this tab */
	static String m_tabPage = "cases/index.jsp";

%><%

	IMSession is = new IMSession(request, response, out);

	String parStudy = request.getParameter("cStudy");
	String parSession = request.getParameter("cSession");
	String parBack = request.getParameter("cBack");

	if ( null == parBack ) {
		parBack = request.getHeader( "Referer" );
	}
	
	// Set login url for the case the user timed out and need to re-login
	is.regDest = (parBack == null ? "/cases/index.jsp" : parBack);

	if (!is.regOK()) {
		return;
	}

	if ( null == parBack ) {
		parBack = "javascript:self.history.back();";
	}

	// Checking user rights
	if (is.regRights == null || (is.regRights.indexOf("@") == -1 && is.regRights.indexOf("A") == -1)) {
		throw new IMGeneralException( is, "You don't have rights to view the requested page", m_tabPage, "Error", parBack);
	}

	if (parStudy == null) {
		throw new IMGeneralException( is, "Missing parameter: cStudy", m_tabPage, "Error", parBack);
	}

	boolean isConfirmPage = !"move".equals(request.getParameter("cOp"));
	boolean isNewSession = false;
	if (parSession == null) {
		parSession = "" + System.currentTimeMillis() + "." + Helper.getCounter();
		isNewSession = true;
	}

	StudyComparator sc = new StudyComparator(parSession, parStudy);
	if (!sc.collectStudyData(is, !isNewSession)) {
		throw new IMGeneralException( is, "<DIV style=\"text-align: left; padding: 20px;\">Study migth be changed on the HUB server.</div>", m_tabPage, "Error", parBack);
	}

	String devices[] = sc.getDevices( is );
	if (devices == null || devices.length < 1) {
		throw new IMGeneralException( is, "<DIV style=\"text-align: left; padding: 20px;\">Study data could not be collected<BR>from the owner HUB server (" + devices[0] + ").</div>", m_tabPage, "Error on HUB server", parBack);
	}

	if (devices.length > 1) {
		// Redirect to the multiple HUB cleanup tool
		response.sendRedirect(is.httpx_host + "/dotcom/parseStudyData.jsp?cStudy=" + Helper.URLEncodeUTF8(parStudy) + "&cSession=" + Helper.URLEncodeUTF8(parSession) + "&cBack=" + Helper.URLEncodeUTF8(parBack));
		return;
	}
	
	// Processing other parameters
	String target = request.getParameter("cTarget");
	if ((target == null || "".equals(target)) && !isConfirmPage) {
		throw new IMGeneralException( is, "<DIV style=\"text-align: left; padding: 20px;\">No target HUB was selected.</div>", m_tabPage, "Error", "javascript:self.history.back();");
	}

	if ( target != null && StudyComparator.rmiIsStudyObsoleteAt( null, parStudy, target ).booleanValue() ) {
		throw new IMGeneralException( is, "<DIV style=\"text-align: left; padding: 20px;\">The study cannot be moved to " + target + ".<BR>The study is obsolete at that HUB.</div>", m_tabPage, "Error", "javascript:self.history.back();" );
	}
	
%><HTML><HEAD><TITLE>Moving study from one HUB to another</title>
<%
	TabToolbox.writeIMpopup(out);
%>
<SCRIPT language="JavaScript">

	var needUnlock = 1; // in default unlock study when leaving page

	function unlockStudy() {
		if (needUnlock) {
			jsPopup('unlockMultiple.jsp?cStudy=<%=parStudy%>&cSession=<%=parSession%>', 'unlockwindow',false);
		}
	}	

	function formSubmit(frm) {
		needUnlock = 0;
		frm.submit();
	}

<%
	if (!isConfirmPage) {
%>
	function getJSElementByID(id) {
		if (document.getElementById)
			return document.getElementById(id);
		else if (document.all)
			return document.all[id];
		else if (document.layers)
			return document.layers[id];
		else
			alert("Browser not compatible"); //TODO
	}

	function changeStyleColor(node, color) {
		var element = getJSElementByID(node);
		element.style.color = color;
	}

	function writeTD(node, text) {
		var element = getJSElementByID(node);
		element.innerHTML = text;
	}
		
<%
	}
%>
</SCRIPT>
<%
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
%>
</head>
<BODY onUnload='unlockStudy()'>
<%
	out.println("<!--");
	for (Enumeration<?> e = request.getParameterNames(); e.hasMoreElements(); ) {
		String name = (String) e.nextElement();
		String values[] = request.getParameterValues(name);
		out.println(name + ":");
		for (int i = 0; i < values.length; i++) {
	out.println("\t[" + values[i] + "]");
		}	
	}
	out.println("-->");


	TabToolbox.makeTabs(is, is.tabbean, m_tabPage, "White");

	Vector<Properties> vLock = new Vector<Properties>();
	String lockOper = isConfirmPage ? ("true".equals(request.getParameter("cBreak")) ? "Break" : "Lock") : "CheckLock";
	
	if (!sc.lock(lockOper, is._sid, false, is, vLock)) {
		// Lock has been stolen
		StringBuffer msg = new StringBuffer();
		msg.append("<H2>");
		for (Iterator<Properties> iter = vLock.iterator(); iter.hasNext(); ) {
	Properties prpLock = iter.next();
	String device = prpLock.getProperty("DEVICE");
	String lockerName = prpLock.getProperty("IMLockOwner");
	String lockAge = prpLock.getProperty("IMLockAge");
	lockerName = (null == lockerName) ? "another user" : IMTypePN.displayOrdinaryText(lockerName);

	msg.append("<BR>The study lock has been locked at " + device + " by " + lockerName + ReportToolbox.getLockAgeMessage(lockAge) + ".<P>\n");
		}

		if (isConfirmPage) {
	if( is.hasRight( PacsRight.BreakLock.letterString()  ) ) {
		msg.append("Break the lock?<BR><BR>");
	}
		}
		msg.append("</H2>");

		MessageBox box = new MessageBox("Lock Error","60%");
		box.setMessage(msg.toString());
		if (isConfirmPage) {
	if( is.hasRight( PacsRight.BreakLock.letterString()  ) ) {
		box.addButton(new Button("javascript:formSubmit(self.document.breakForm);", "BUTTON_BREAK", "BUTTON_BREAK_TITLE" ));
	}
		}

		box.addButton(new Button(parBack, "BUTTON_BACK", "BUTTON_BACK_TITLE" ));
%><BR>
 <FORM METHOD="POST" NAME="breakForm" ACTION="/dotcom/moveStudy.jsp">
 <INPUT TYPE="HIDDEN" NAME="cStudy" VALUE="<%= Helper.htmlEncode(parStudy) %>">
 <INPUT TYPE="HIDDEN" NAME="cSession" VALUE="<%= Helper.htmlEncode(parSession) %>">
 <INPUT TYPE="HIDDEN" NAME="cBack" VALUE="<%= Helper.htmlEncode(parBack) %>">
 <INPUT TYPE="HIDDEN" NAME="cBreak" VALUE="true"></FORM>
<CENTER><%

		box.print(is.out);
%>
</CENTER></BODY></HTML>
<%
		return;
	}

	if (!isConfirmPage) {
		// DICOM objects exist on the HUB the study to be reside on
//		Set<ObjectData> images = sc.getImages(target);

		
		// DICOM objects do not exist on the HUB the study to be reside on
		int i = 0;

		// print to-do table
%>
 <BR><BR>
 <CENTER><table width="50%" border=1 cellpadding=2 cellspacing=2><tr class=BgShadow><td>
 <table width="100%" border=0 style="color: gray"><COL><COL align=center width="20%">
 <%
		out.println("<tr id=\"trlock\"><td>System lock studies at HUB servers</td><td width=\"10%\" id=\"tdlock\">&nbsp;</td></tr>");
		for (i = 0; i < devices.length; i++) {
			if (target.equals(devices[i])) {
				continue;
			}

			out.println("<tr id=\"trgetobj_" + devices[i] + "\"><td>Get objects from " +
					devices[i] + "</td><td id=\"tdgetobj_"+ devices[i] + "\">&nbsp;</td></tr>");
		}

		out.println("<tr id=\"trsetowner\"><td>Set " + target + " to be the study owner</td><td id=\"tdsetowner\">&nbsp;</td></tr>");

		String putProcessMsg = "Put images to " + target;
		out.println("<tr id=\"trputprocess\"><td>" + putProcessMsg + "</td><td id=\"tdputprocess\">&nbsp;</td></tr>");

		for (i = 0; i < devices.length; i++) {
			if (target.equals(devices[i]))
				continue;
			out.println("<tr id=\"trobsolete\"><td>Set study obsolete at all devices except " +
					target + "</td><td id=\"tdobsolete\">&nbsp;</td></tr>");
		}
		
		out.println("<tr id=\"trunlock\"><td>Unlock studies at HUB servers</td><td id=\"tdunlock\">&nbsp;</td></tr>");

%>
 </table></tr></td></table><BR><BR><BR>
<%
	// start the correction
		out.flush();

		// System Lock studies
		CorrectionTool.nextStep(is.out, "trlock");
		if (! CorrectionTool.checkResult(is.out, CorrectionTool.systemLock(sc, is), parBack, "tdlock")) {
	return;
		}

		// Get object data to be prepared from HUBs the study will be removed from

		// multipart request to be sent to the HUB the study will remain on
		MultipartRequest mpr = new MultipartRequest();

		mpr.addParam("cStudy", parStudy, MultipartRequest.MP_STRING_PARAM);
		mpr.addParam("cSession", parSession, MultipartRequest.MP_STRING_PARAM);
		if (is.regID != null) {
	mpr.addParam("cUser", is.regID, MultipartRequest.MP_STRING_PARAM);
		}

		int numTarFiles = 0;
		for (i = 0; i < devices.length; i++) {
	if (target.equals(devices[i])) {
		continue;
	}

	CorrectionTool.nextStep(is.out, "trgetobj_"+devices[i]);

	File dataFile = new File(IMEnvBase.getEnv("TMP") + "/multihub." + parSession + "." + devices[i] + ".tar.gz");
	MessageBox mb = CorrectionTool.getObjectsFrom(dataFile, parStudy, parSession, devices[i], true, true, null, is.regID, target);
	
	if (! CorrectionTool.checkResult(is.out, mb, parBack, "tdgetobj_" + devices[i])) {
		return;
	}

	if( dataFile.length() != 0 ) {
		mpr.addParam("cHub" + numTarFiles, devices[i], MultipartRequest.MP_STRING_PARAM);
		mpr.addParam("cFile" + numTarFiles, dataFile.getAbsolutePath(), MultipartRequest.MP_FILE_PARAM);
		numTarFiles++;
	}
		}
		
		mpr.addParam("cNumFiles", "" + numTarFiles, MultipartRequest.MP_STRING_PARAM);
		mpr.addParam("cDelReport", "false", MultipartRequest.MP_STRING_PARAM);
		mpr.addParam("cMove", "true", MultipartRequest.MP_STRING_PARAM);

		// Set target device to be the owner
		CorrectionTool.nextStep(is.out, "trsetowner");
		if (! CorrectionTool.checkResult(is.out, CorrectionTool.setOwnerTo(is, target, parStudy), parBack, "tdsetowner")) {
	return;
		}

		// Put object data to the HUB the study will reside on
		CorrectionTool.nextStep(is.out, "trputprocess");
		if ( !CorrectionTool.checkResult( is.out, CorrectionTool.putObjectsTo( is.out, target, parSession, mpr ), parBack, "tdputprocess" ) ) {
	return;
		}

		// Remove study from other HUBs
		CorrectionTool.nextStep(is.out, "trobsolete");
		if (! CorrectionTool.checkResult(is.out, CorrectionTool.obsoleteStudy( is, parStudy, parSession, null, is.regID, target),
		parBack, "tdobsolete")) {
	return;
		}

		// Release System lock
		CorrectionTool.nextStep(is.out, "trunlock");
		sc.lock("Unlock", is._sid, true, is, vLock);
		CorrectionTool.checkResult(is.out, null, null, "tdunlock");

		MessageBox mb = new MessageBox("Done","60%");
		mb.setMessage("<H2><BR>Study has been successfully moved to " + target + ".<BR><BR></H2>");
		mb.addButton(new Button(parBack, "BUTTON_BACK", "BUTTON_BACK_TITLE" ));
		mb.print(is.out);
%>
<SCRIPT language="JavaScript">
	needUnlock = 0; 
</SCRIPT>
</BODY></HTML><%
		return;
	}
%>
<CENTER>
<BR>
<FORM METHOD="POST" NAME="moveForm" ACTION="/dotcom/moveStudy.jsp">
<INPUT TYPE="HIDDEN" NAME="cStudy" VALUE="<%= Helper.htmlEncode(parStudy) %>">
<INPUT TYPE="HIDDEN" NAME="cSession" VALUE="<%= Helper.htmlEncode(parSession) %>">
<INPUT TYPE="HIDDEN" NAME="cBack" VALUE="<%= Helper.htmlEncode(parBack) %>">
<INPUT TYPE="HIDDEN" NAME="cOp" VALUE="move">
<%
	StringBuffer msg = new StringBuffer();
	msg.append("Move study from " + devices[0] + " to<BR><BR>");
	msg.append("<SELECT NAME=\"cTarget\">\n");
	msg.append("<OPTION VALUE=\"\"> --- SELECT TARGET ---\n");
	
	List<String> hubs = DotcomConfig.getConfig().getHubs( DotcomConfig.selfId() );
	
	for (int i = 0; i < hubs.size(); i++) {
		String hub = hubs.get( i ); 
		if (devices[0].equals( hub ))
			continue;
	
		msg.append("<OPTION VALUE=\"" + hub + "\">" + hub + "\n");
	}
	msg.append("</SELECT>\n<BR>");
	

	MessageBox messageBox = new MessageBox("Move study from one HUB to another", "60%");
	messageBox.setMessage("<BR>" + msg + "<BR>");
	messageBox.addButton(new Button("javascript:formSubmit(self.document.moveForm)", "BUTTON_MOVE", "BUTTON_MOVE_STUDY_HUB"));
	messageBox.addButton(new Button(parBack, "BUTTON_CANCEL", "BUTTON_CANCEL_TITLE"));

	messageBox.print(is.out);
%>
</FORM>
</CENTER></BODY></HTML>
--%>