<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: imadmin
 *
 * Description:
 *   Check if remote device is available
 *
 * For DICOM devices sends C-ECHO request, for non DICOM devices sends ping to check if the remote device is available.
 *
 * Parameters:
 *
 *  - From device table
 *    p_id     : ID of the device to be checked
 *
 *  - From device edit page (to check before save settings)
 *    cHost     : Host name/IP address of the device
 *    cType     : Host type
 *    cPort     : Port number (DICOM/HL7)
 *    cProtocol : TCP/TLS
 *    cId       : device id
 *		cAET			: aetitle (for dicom devices only)
 *
 * $Author$
 * $Date$
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
-- %><%@
	page import="imagemed.util.*,imagemed.exception.*,imagemed.imsession.*,java.util.*,java.io.*,
			java.sql.*,imagemed.jsputil.*,java.text.Format"

%><%-- ---- Input Parameters --- -- %><%
	IMSession is = new IMSession(request, response, out); 
	if (!is.regOK()) {
		return;
	}
	String parId       = request.getParameter("p_id");
	boolean isPopup		 = request.getParameter("cHost") != null;
	String cHost			 = request.getParameter("cHost");
	String cType			 = request.getParameter("cType");
	String cPort			 = request.getParameter("cPort");
	String cProtocol	 = request.getParameter("cProtocol");
	String cId				 = request.getParameter("cId");
	String cAET				 = request.getParameter("cAET");

%><%!
	String getPw() {
		String cmd[] = new String[1];
		cmd[0] = IMEnvBase.getEnv("OPENSSL_PASS");
		String pw = Helper.runCommand(cmd, null);
		return (pw == null) ? "" : pw.trim();
	}

	Properties ping(String host, int nAttempt, int nTimeoutSec) {
		Properties resultPrp = null;
		try {
			String cmd[] = new String[6];
			cmd[0] = "/bin/ping";
			cmd[1] = "-c";
			cmd[2] = "" + nAttempt;
			cmd[3] = "-w";
			cmd[4] = "" + nTimeoutSec;
			cmd[5] = host;
			RunCommandResult res = Helper.runCommandEx(cmd, null);
			String stdout = res.getOutput();
			String stderr = res.getError();
			resultPrp = new Properties();
			resultPrp.setProperty("stdout", stdout == null ? "" : stdout);
			resultPrp.setProperty("stderr", stderr == null ? "" : stderr);
		}
		catch (Throwable th) {
		}
		return resultPrp;
	}

	Properties echoSCU(String host, int port, String callingae, String ourae, boolean isSecure) {
		String pw = null;
		Properties resultPrp = null;
		try {
			int nArgs = 4;
			nArgs += "".equals(callingae) ? 0 : 2;
			nArgs += "".equals(ourae) ? 0 : 2;
			nArgs += isSecure ? 5 : 0;
			int n = 0;
			String cmd[] = new String[nArgs];
			cmd[n++] = IMEnvBase.getEnv("DCMTK_HOME") + "/bin/echoscu";
			cmd[n++] = "-v";
			if (!"".equals(callingae)) {
				cmd[n++] = "--call";
				cmd[n++] = callingae;
			}
			if (!"".equals(ourae)) {
				cmd[n++] = "-aet";
				cmd[n++] = ourae;
			}
			if (isSecure) {
				cmd[n++] = "+tls";
				cmd[n++] = IMEnvBase.getEnv("SSL_SITE_KEY");
				cmd[n++] = IMEnvBase.getEnv("SSL_SITE_CERT");
				cmd[n++] = "-ic";
				cmd[n++] = "+ps";
				pw = getPw();
			}
			cmd[n++] = host;
			cmd[n++] = "" + port;
			if (isSecure && "".equals(pw)) {
				// should return with error
				return null;
			}
			Process p = Runtime.getRuntime().exec(cmd);
			if (isSecure) {
				OutputStream os = p.getOutputStream();
				os.write(pw.getBytes());
				os.close();
			}
			InputStream isOut = p.getInputStream();
			InputStream isErr = p.getErrorStream();
			p.waitFor();
			String stdOut = "";
			String stdErr = "";
			byte[] buff = new byte[1024];
			try {
				int r = 0;
				while (-1 != (r = isOut.read(buff))) {
					String str = new String(buff, 0, r);
					stdOut = stdOut + str;
				}
				isOut.close();
			}
			catch (Throwable th) {
			}
			try {
				int r = 0;
				while (-1 != (r = isErr.read(buff))) {
					String str = new String(buff, 0, r);
					stdErr = stdErr + str;
				}
				isErr.close();
			}
			catch (Throwable th) {
			}
			resultPrp = new Properties();
			resultPrp.setProperty("stdout", stdOut);
			resultPrp.setProperty("stderr", stdErr);
			p.destroy();
		}
		catch (Throwable th) {
			resultPrp = null;
		}
		return resultPrp;
	}
%><HTML>
<HEAD><%=isPopup?"":"<TITLE>" + LocalizedMessage.getSimpleMessage( "IMADMIN_ECHO_TITLE" ) + "</TITLE>"%>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
%>
</HEAD>
<BODY>
<%
	if (!isPopup) {
		TabToolbox.makeTabs( is, is.tabbean, "imadmin/dicom.jsp", "White");
	}
%><%
	if (!IMAdminToolbox.bAdminRight(is)) {
%>
<BR>
<CENTER><H3>
<%= LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) %>
</H3></CENTER></BODY></HTML>
<%
		return;
	}

	String host = null;
	int port = 104;
	String aetitle = null;
	String protocol = "T";
	String type = "D";
	if (isPopup) {
		host = cHost;
		try {
			port = Integer.parseInt(cPort);
		}
		catch (Throwable th) {
			port = -1;
		}
		aetitle = cAET;
		protocol = cProtocol;
		type = cType;
		parId = cId;
	}
	else {
		try {
			PreparedStatement ps = IMEnv.getDB().prepareStatement("select HOST, PORT, AE, PROTOCOL, TYPE from " +
					IMEnvBase.getEnv("TARGETTBL") + " where ID='" + parId + "'");
			ResultSet rs = ps.executeQuery();

			if (rs.next()) {
				host = rs.getString("HOST");
				port = rs.getInt("PORT");
				aetitle = rs.getString("AE");
				protocol = rs.getString("PROTOCOL");
				type = rs.getString("TYPE");
			}
		}
		catch(SQLException sqlEx) {
		}

		if (host == null) {
			String parIdMsg = (parId == null? "" : parId);
			throw new IMGeneralException(LocalizedMessage.getCompoundMessage( "EXCEPTION_IMADMIN_ECHO_NO_SUCH_DICOM_MSG", new Format[] { null }, new Object[] { parIdMsg }, true),
					"imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_ECHO_NO_SUCH_DICOM" ),null);
		}
	}
	String result = null;
	String error  = null;

	boolean isDicom = "D".equals(type) || "P".equals(type) || "C".equals(type); // Dicom, Parent, Child

	if (!isDicom) {
		try {
			Properties prpResult = ping(host, 5, 30);
			result = prpResult.getProperty("stdout", "");
			error  = prpResult.getProperty("stderr", "");
		}
		catch (Throwable th) {
		}
    
		if (result == null && !isPopup) {
			throw new IMGeneralException(LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_ECHO_COULD_NOT_PING_HL7_MSG" ),
					"imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_ECHO_COULD_NOT_PING_HL7" ), null);
		}
	}
	else {
		if (aetitle == null || "*".equals(aetitle))
			aetitle = "";

		try {
			IMProperties prpPbScp = new IMProperties();
			prpPbScp.recRead(IMEnvBase.getEnv("DICOM_VAR") + "/pb-scp.cfg");
			String ouraetitle = prpPbScp.getProperty("AE_TITLE","");

			Properties prpResult = echoSCU(host, port, aetitle, ouraetitle, "S".equals(protocol));

			result = prpResult.getProperty("stdout", "");
			error  = prpResult.getProperty("stderr", "");
		}
		catch (Throwable th) {
		}

		if (result == null && !isPopup) {
			throw new IMGeneralException(LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_ECHO_COULD_NOT_ECHO_DICOM_MSG" ),
					"imadmin/dicom.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_IMADMIN_ECHO_COULD_NOT_ECHO_DICOM" ), null);
		}
	}

%>
<center>
<% if (isDicom) { %>
<h3> <%= LocalizedMessage.getCompoundMessage( "IMADMIN_ECHO_SEND_ECHO_TO", new Format[] { null }, new Object[] { parId }, true ) %></h3>
<h4> <%= host %>:<%=port%> <%= "".equals(aetitle) ? "" : "["+ aetitle +"]"%></h4>
<% } else { %>
<h3> <%= LocalizedMessage.getCompoundMessage( "IMADMIN_ECHO_SEND_PING_TO", new Format[] { null }, new Object[] { parId }, true ) %></h3>
<h4> <%= host %></h4>
<% } %>
<BR>
<TABLE border=1 width="70%">
<TR class=HeaderRow><%= Helper.headerCell3D(isDicom ? "  " + LocalizedMessage.getSimpleMessage( "IMADMIN_ECHO_ECHO_RESULT" ) : "  " + LocalizedMessage.getSimpleMessage( "IMADMIN_ECHO_PING_RESULT" ) ) %></TR>
<TR><TD class=BgLight>
<pre>
<%= result==null?"":result %><%= error == null ? "" : error %>
</pre>
</TD></TR>
<TR><TD class=BgShadow align=right>
<%
	if (isPopup) {%>
<a href="javascript:window.close();"
onMouseOver="window.status='Close'; return true">
<%= JSHelper.getJsLocalizedButton( "BUTTON_CLOSE", "BUTTON_CLOSE", false ) %>
</a>
<%}
	else {
%>
<a href="javascript:self.history.back();"
onMouseOver="window.status='Back'; return true">
<%= JSHelper.getJsLocalizedButton( "BUTTON_BACK", "BUTTON_NULL", false ) %>
</a>
<%}%>
</TD></TR>
</TABLE>
</CENTER></BODY></HTML>
--%>