var currentSelect;
var currentDiv;
var currentHidden;

/*
 *  Opens the 'select from list' layer
 */
function openSelectLayer( selectId, titleSelected, titleAll, oSelected, oAll ) {
	// if ( hasPageRefreshTimer ) {
	//	cancelTablePageRefreshTimer();
	// }
	var selectDiv = getelementbyid( 'selectDiv' );
	var transparentDiv = getelementbyid( 'transparency' );
	transparentDiv.style.display = "block";
	selectDiv.style.visibility = "visible";
	selectDiv.style.zIndex = 9999;

	var wleft = (document.all) ? document.body.scrollLeft : window.pageXOffset;
	var wtop = (document.all) ? document.body.scrollTop : window.pageYOffset;

	var winWidth = document.body.clientWidth;
	var winHeight = document.body.clientHeight;

	if ( typeof( window.innerWidth ) == 'number' ) {
		winWidth = window.innerWidth;
		winHeight = window.innerHeight;
	}
	
	var centerX = wleft + ( winWidth / 2 );
	var centerY = wtop + ( winHeight / 2 );

	var divWidth = selectDiv.clientWidth;
	var divHeight = selectDiv.clientHeight;
	var divLeft = (centerX - ( divWidth / 2 ) );
	var divTop = (centerY - ( divHeight / 2 ) );
	
	selectDiv.style.left = divLeft + "px";
  selectDiv.style.top = divTop + "px";

  var titleS = getelementbyid( 'selectedTitle' );
  titleS.innerHTML = titleSelected;

  var titleA = getelementbyid( 'availableTitle' );
  titleA.innerHTML = titleAll;

  var sList = self.document.selectListForm.selectedList;
  var aList = self.document.selectListForm.allList;

	clearSelect( sList );
	clearSelect( aList );
  
  fillSelect( sList, oSelected );
	fillSelect( aList, oAll );
	for ( var i = 0; i < aList.options.length; i++ ) {
		if ( contains( sList, aList.options[ i ] ) ) {
			aList.options[ i ] = null;
			i--;
		}
	}
	
	sortOptionsByText( sList );
	sortOptionsByText( aList );
	currentSelect = oSelected;
	currentDiv = getelementbyid( selectId + 'Div' );
	currentHidden = getelementbyid( selectId + 'Hidden' );
}

/*
 * Hides the 'select from list' layer
 */
function hideSelectLayer() {
	var selectDiv = getelementbyid( 'selectDiv' );
	var transparentDiv = getelementbyid( 'transparency' );
	transparentDiv.style.display = "none";
	selectDiv.style.visibility = "hidden";

	//if ( hasPageRefreshTimer ) {
	//	startTablePageRefreshTimer();
	//}
}

function applySelectChanges() {
	if ( currentSelect != undefined ) {
		copySelect( currentSelect, self.document.selectListForm.selectedList);

		if ( currentDiv != undefined ) {
			updateDiv( currentDiv, currentSelect );
		}
		
		if ( currentHidden != undefined ) {
			updateHidden( currentHidden, currentSelect );
		}

		currentSelect = undefined;
		currentDiv = undefined;
		currentHidden = undefined;
	}

	hideSelectLayer();
}

function initDivHidden( nameSelect, nameDiv, nameHidden ) {
	var oSelect = getelementbyid( nameSelect );
	var oDiv = getelementbyid( nameDiv );
	var oHidden = getelementbyid( nameHidden );
	updateDiv( oDiv, oSelect );
	updateHidden( oHidden, oSelect );
}


/*
 * Checks if a select object contains a specific options
 * (there is an option in the select list having the same value as the argument option)
 *
 * oSelect - select object to be checked for the option
 * oObject - select option to be searched for
 */
function contains( oSelect, oOption ) {
	for ( var i = 0; i < oSelect.options.length; i++ ) {
		if ( oSelect.options[ i ].value == oOption.value )
			return true;
	}

	return false;
}


/*
 * Comparator function for sorting select options by display text
 *
 * a, b - Option objects of a select list to be sorted
 */
function compareOptionsByText( a, b ) {
	if ( a.text.toLowerCase() == b.text.toLowerCase() )
		return 0;
	return a.text.toLowerCase() < b.text.toLowerCase() ? -1 : 1;
}


/*
 * Comparator function for sorting select options by display text
 *
 * a, b - Option objects of a select list to be sorted
 */
function compareOptionsByValue( a, b ) {
	if ( a.value == b.value )
		return 0;
	return a.value < b.value ? -1 : 1;
}


/*
 * Sorts the options of a select list by option display text
 * 
 * oSelect  select list
 */
function sortOptionsByText( oSelect ) {
	if ( oSelect.options.length <= 0 )
		return;

	var optionArray = new Array( oSelect.options.length );
	var i;
	for ( i = 0; i < oSelect.options.length; i++ ) {
		optionArray[ i ] = new Option( oSelect.options[ i ].text,
				oSelect.options[ i ].value);
		optionArray[ i ].title = oSelect.options[ i ].title;
	}

	optionArray.sort( compareOptionsByText );
	for ( i = 0; i < optionArray.length; i++ ) {
		oSelect.options[ i ] = optionArray[ i ];
	}
}


/*
 * Moves selected options from one select object to another
 *
 * oFrom - source select object to move selected options from
 * oTo   - destination select object the selected optins to be moved to
 */
function moveSelectedOptions( oFrom, oTo ) {
	// var selectedIndex; /* selected Index */
	for ( var i = 0; i < oFrom.options.length; i++ ) {
		if ( !oFrom.options[ i ].selected ) {
			continue;
		}

		if ( !contains( oTo, oFrom.options[ i ] ) ) {
			var pos = oTo.length;
			oTo.options[ pos ] = new Option( oFrom.options[ i ].text,
					oFrom.options[ i ].value );
			oTo.options[ pos ].title = oFrom.options[ i ].title;
		}

		oFrom.options[ i ] = null;
		i--; /* make the loop go through them all */
	}

	sortOptionsByText( oTo );
}


/*
 * Fills the target select list from the source select list
 *
 * oTarget - select list to be filled
 * oSource - source select list
 */
function fillSelect( oTarget, oSource ) {
	for ( var i = 0; i < oSource.options.length; i++ ) {
		if ( oSource.options[ i ].value == '' ) {
			oTarget.options[ i ] = new Option( oSource.options[ i ].text,
					oSource.options[ i ].text );
		}
		else {
			oTarget.options[ i ] = new Option( oSource.options[ i ].text,
					oSource.options[ i ].value );
		}
		oTarget.options[ i ].title = oSource.options[ i ].title;
	}
}


/*
 * Select all options in a select list
 *
 * oSelect - select object
 */
function selectAll( oSelect ) {
	for ( var i = 0; i < oSelect.options.length; i++ ) {
		oSelect.options[ i ].selected = true;
	}
}


/*
 * Deselect all options in a select list
 *
 * oSelect - select object
 */
function deselectAll( oSelect ) {
	for ( var i = 0; i < oSelect.options.length; i++ ) {
		oSelect.options[ i ].selected = false;
	}
}


/*
 * Copies all options from a select object to another.
 * Pre-existing options of the target select object will be cleared.
 *
 * oTarget - target select object options to be copied to
 * oSource - source select object to be copied
 */
function copySelect( oTarget, oSource ) {
	var i;
	for ( i = 0; i < oSource.options.length; i++ ) {
		oTarget.options[ i ] = new Option( oSource.options[ i ].text, oSource.options[ i ].value );
		oTarget.options[ i ].title = oSource.options[ i ].title;
	}

	// Clear remaining options in target
	while ( i < oTarget.options.length ) {
		oTarget.options[ i ] = null;
	}
}

/*
 * Removes all options from the select object
 */
function clearSelect( oSelect ) {
	for ( var i = 0; i < oSelect.options.length; i++ ) {
		oSelect.options[ i ] = null;
		i--; /* make the loop go through them all */
	}
}

/*
 * Fills div with <BR> separated list from display values of options in a select box 
 */
function updateDiv( oDiv, oSelect ) {
	var htmlContent = "";
	
	sortOptionsByText( oSelect );
	
	for ( var i = 0; i < oSelect.options.length; i++ ) {
		if ( oSelect.options[ i ].title != null && oSelect.options[ i ].title != '' ) {
			htmlContent += oSelect.options[ i ].title + "<BR/>";
		}
		else if ( oSelect.options[ i ].text == '' ) {
			htmlContent += oSelect.options[ i ].value + "<BR/>";
		}
		else {
			htmlContent += oSelect.options[ i ].text + "<BR/>";
		}
	}
	
	oDiv.innerHTML = htmlContent;
}

/*
 * Fills hidden text input with new line separated list from values of options in a select box 
 */
function updateHidden( oHidden, oSelect ) {
	var hiddenValue = "";
	
	for ( var i = 0; i < oSelect.options.length; i++ ) {
		if ( oSelect.options[ i ].value == '' )
			hiddenValue += oSelect.options[ i ].text + "\n";
		else
			hiddenValue += oSelect.options[ i ].value + "\n";
	}
	
	oHidden.value = hiddenValue; 
}


///*
// * Initialize the select lists based on the content of the opener page
// */
//function initSelects() {
//	oOpenerDevice = opener.document.dcmForm.deviceSOP;
//	oOpenerAll = opener.document.dcmForm.systemSOP;
//	oDevice = self.document.sopClassForm.deviceSOP;
//	oAll = self.document.sopClassForm.allSOP;
//
//	fillSelect(oDevice, oOpenerDevice);
//	fillSelect(oAll, oOpenerAll);
//
//	for ( var i = 0; i < oAll.options.length; i++) {
//		if (contains(oDevice, oAll.options[i])) {
//			oAll.options[i] = null;
//			i--;
//		}
//	}
//
//	sortOptionsByText(oDevice);
//	sortOptionsByText(oAll);
//}
//
///*
// * Applies changes by copying the content of the device select list back to the opener window 
// */
//function applyChanges() {
//	opener.copySelect(oOpenerDevice, oDevice);
//	window.close();
//}
