DEPENDENCIES = new Array();
IMPLICATIONS = new Array();

INV_DEPENDENCIES = new Array();
INV_IMPLICATIONS = new Array();

function addRightsDependencies( right, dependants ) {
	DEPENDENCIES[ right ] = dependants;
	for ( var i = 0; i < dependants.length; i++) {
		var invRight = dependants[ i ];
		if ( !INV_DEPENDENCIES[ invRight ] ) {
			INV_DEPENDENCIES[ invRight ] = new Array();
		}
		INV_DEPENDENCIES[ invRight ].push( right );
	}
};

function addRightsImplications( right, implicants ) {
	IMPLICATIONS[ right ] = implicants;
	for ( var i = 0; i < implicants.length; i++) {
		var invRight = implicants[ i ];
		if ( !INV_IMPLICATIONS[ invRight ] ) {
			INV_IMPLICATIONS[ invRight ] = new Array();
		}
		INV_IMPLICATIONS[ invRight ].push( right );
	}
};

GroupEditMap = {};

function isGroupEdit( name ) {
	if ( typeof GroupEditMap[ name ] == 'undefined' ) {
		try {
			getRightsCbHandler( name, 'g' );
			GroupEditMap[ name ] = false;
		}
		catch ( e ) {
			GroupEditMap[ name ] = true;
		}
	}
	return GroupEditMap[ name ];
}

var ONVALUE = 2;
var OFFVALUE = 1;
var FORCEDOFFVALUE = 0;

var IMGNAMEPARTS = new Array();
IMGNAMEPARTS[ FORCEDOFFVALUE ] = "ForcedOff";
IMGNAMEPARTS[ OFFVALUE ] = "Off";
IMGNAMEPARTS[ ONVALUE ] = "On";

var passwordColids = ["_UPWD_", "_UPW2_", "_UPEX_", "_UPXD_", "_UPRV_", "_UPMC_"];
var pwColidPrefixes = [ "", "", "", "", "", "qe_" ]

function setPasswdFieldsEnabled( fieldName, disable ) {
	if ( fieldName.startsWith( 'qi_' ) ) {
		fieldName = fieldName.substr( 3 );
	}
	if ( fieldName.endsWith( '_g' ) ) {
		fielName = fieldName.substring( fieldName.length - 2 ); // strip leading 'qi_' and trailing '_g'
	}
	for ( var i = 0; i < passwordColids.length; i++) {
		var pwFieldName = pwColidPrefixes[ i ] + fieldName.replace( "_USAT_", passwordColids[ i ] );
		if (TYPES[pwFieldName]) { // registered input
			var nodes = getNodes( pwFieldName );
			$.each( nodes, function( index, value ) {
				if (value) {
				  value.disabled = disable ? true : false;
				}//qe__FFP_Access_&36;&38;&3d;2__UPMC__CB
				// qe__FFP_Access_&36;&38;&3d;2__UPMC__CB
			});
		}
	}
}

function isHardOff( name, right ) {
	if ( isGroupEdit( name ) ) {
		return false;
	}
	var selectName = name.replace( '_URGT_', '_UGRP_' );
	var selectedGroupsHardRights = new String( groupHardRights[ document.getElementById( "id_" + selectName + "_sel" ).selectedIndex ] );
	return selectedGroupsHardRights.indexOf( right ) >= 0;
}

function changeGroup( name ) {
	var rightName = name.replace( '_UGRP_', '_URGT_' ).replace( '_USAT_', '_URGT_' );
	var selectName = name.replace( '_URGT_', '_UGRP_' ).replace( '_USAT_', '_UGRP_' );
	var authTargetSelect = name.replace( '_URGT_', '_USAT_' ).replace( '_UGRP_', '_USAT_' );
	var selGroupIndex = document.getElementById( "id_" + selectName + "_sel" ).selectedIndex;
	if ( name != rightName && typeof AUTH_GRP !== 'undefined') {
		// auth mode or group altered, auth mode is on the form, should adjust enabled state of password inputs
		var isLDAP;
		var authTarget = $( jq( authTargetSelect ) ).val();
		if ( authTarget == AUTH_GRP ) {
			isLDAP = isGroupLdap[ selGroupIndex ];
		}
		else if ( authTarget == AUTH_SYS ){
			isLDAP = systemIsLdap;
		}
		else {
			isLDAP = ( authTarget != AUTH_EP );
		}
		setPasswdFieldsEnabled( authTargetSelect, isLDAP );
		if ( name == authTargetSelect) {
			return; // auth mode altered, no need to update rights
		}
	}
	if ( isGroupEdit( rightName ) || getRightsCbHandler( rightName, "g" ).value != ONVALUE ) {
		// need to adjust hardoff states
		for ( var i = 0; i < settableRights.length; i++) {
			var right = settableRights.charAt( i );
			getRightsCbHandler( rightName, right ).adjustValueRange();
		}
		return false;
	}
	selectedGroupsRights = new String( groupRights[ selGroupIndex ] );
	for ( var i = 0; i < settableRights.length; i++) {
		var right = settableRights.charAt( i );
		getRightsCbHandler( rightName, right ).setState( selectedGroupsRights.search( right ) > -1 ? ONVALUE : isHardOff( rightName, right ) ? FORCEDOFFVALUE : OFFVALUE, true );
	}
	return true;
};

function clicked( name, right ) {
	// check whether the checkbox is enabled and return if not
	var checkBox = getRightsCbHandler( name, right );
	if ( checkBox.disabled ) {
		return;
	}
	// switch it to the next state
	checkBox.stepValue();
};

function update( name, right ) {
	getRightsCbHandler( name, right ).update();
};

CbHandlerCache = {};

function getRightsCbHandler( name, right ) {
	if ( typeof CbHandlerCache[ name ] == 'undefined' ) {
		CbHandlerCache[ name ] = {};
	}
	if ( typeof CbHandlerCache[ name ][ right ] == 'undefined' ) {
		CbHandlerCache[ name ][ right ] = new RightsCheckboxHandler( name, right );
	}
	return CbHandlerCache[ name ][ right ];
};

function getValue( name, right ) {
	return getRightsCbHandler( name, right ).value;
}

function RightsCheckboxHandler( name, right ) {
	this.name = name;
	this.right = right;
	this.disabled = false;
	var idSuffix = "_" + right + ( right == right.toUpperCase() ? "" : "_" );
	this.img = my_getelementbyid( "ur_img_" + name + idSuffix );
	this.hidden = my_getelementbyid( "ur_" + name + idSuffix );
	this.value = parseInt( this.hidden.value );
	this.hardMinValue = OFFVALUE;
	if ( right != 'g' && isGroupEdit( name ) ) {
		this.hardMinValue = FORCEDOFFVALUE;
	}
	this.hardMaxValue = ONVALUE;

	this.adjustValueRange = function() {
		if ( isHardOff( this.name, this.right ) ) {
			this.minValue = FORCEDOFFVALUE;
			this.maxValue = FORCEDOFFVALUE;
		}
		else {
			this.minValue = this.hardMinValue;
			this.maxValue = this.hardMaxValue;
			// check rights we depend on
			if ( INV_DEPENDENCIES[ this.right ] != undefined ) {
				var inv_deps = INV_DEPENDENCIES[ this.right ];
				for ( var i = 0; i < inv_deps.length; i++) {
					var dependant = inv_deps[ i ];
					var negated = dependant.startsWith( '!' );
					if ( negated ) {
						// negation must not be user for anything but the 'g' right, so we handle it specially
						dependant = dependant.substr( 1 );
					}
					var depVal = getValue( this.name, dependant );

					if ( !negated && this.maxValue > depVal ) {
						this.maxValue = depVal;
					}
				}
			}
			// check rights that imply us
			if ( INV_IMPLICATIONS[ this.right ] != undefined ) {
				var inv_imps = INV_IMPLICATIONS[ this.right ];
				for ( var i = 0; i < inv_imps.length; i++) {
					var impVal = getValue( this.name, inv_imps[ i ] );
					if ( this.minValue < impVal ) {
						this.minValue = impVal;
					}
				}
			}
		}
		var newVal = this.value;
		if ( newVal < this.minValue ) {
			newVal = this.minValue;
		}
		if ( newVal > this.maxValue ) {
			newVal = this.maxValue;
		}
		this.setState( newVal, this.minValue >= this.maxValue );
	};

	this.update = function() {
		if ( "g" == this.right && changeGroup( this.name ) ) {
			return;
		}
		// trigger rights depending on us
		if ( DEPENDENCIES[ this.right ] != undefined ) {
			var deps = DEPENDENCIES[ this.right ];
			for ( var j = 0; j < deps.length; j++) {
				getRightsCbHandler( this.name, deps[ j ] ).adjustValueRange();
			}
		}
		if ( DEPENDENCIES[ "!" + this.right ] != undefined ) {
			var deps = DEPENDENCIES[ "!" + this.right ];
			for ( var j = 0; j < deps.length; j++) {
				getRightsCbHandler( this.name, deps[ j ] ).adjustValueRange();
			}
		}
		// trigger rights implied by us
		if ( IMPLICATIONS[ right ] != undefined ) {
			var imps = IMPLICATIONS[ right ];
			for ( var j = 0; j < imps.length; j++) {
				getRightsCbHandler( this.name, imps[ j ] ).adjustValueRange();
			}
		}
	};

	this.setDisabled = function( disabled ) {
		if ( disabled == this.disabled ) {
			return;
		}
		this.disabled = disabled;
		this.updateImg();
	};

	this.stepValue = function() {
		var val = this.value + 1;
		if ( val > this.maxValue ) {
			val = this.minValue;
		}
		this.setValue( val );
	};

	this.setValue = function( value ) {
		if ( this.value != value ) {
			this.value = value;
			this.hidden.value = "" + value;
			this.updateImg();
		}
		this.update();
	};

	this.setState = function( value, disabled ) {
		if ( this.value == value ) {
			this.setDisabled( disabled );
		}
		else {
			this.disabled = disabled;
		}
		this.setValue( value );
		this.updateImg();
	};

	this.updateImg = function() {
		this.img.src = "/art/img/cb" + IMGNAMEPARTS[ this.value ] + ( this.disabled ? ".d" : "" ) + suffix + ".gif";
		this.img.style.cursor = this.disabled ? "default" : "pointer";
	};

	// this.adjustValueRange();
};

