#!/bin/sh
#
# Component: qr
#
# Description:
#   OBSOLETE [7.0]
#   Removes archive_..._get reference from a study after an unsuccessful retrieve attempt on a remote dotcom device (peer).
#   The peer is intended to be a staged device from where the retrieve attempt probably was initiated.
#
# Usage:
#   clearArchiveRefOnPeer.sh -s <study> -r <reference> -H <hostID>

#    - study:      Study Instance UID of the study tried to be retrieved
#    - reference:  Full name of the archive_..._get reference to be removed
#    - hostID:     Device ID of the peer
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

# if clearArchiveRefOnPeer.sh is called directly:
# run as a task instead
if [ `basename $0` = "clearArchiveRefOnPeer.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi


LOGGER="/usr/bin/logger"
TAG="clearArchiveRefOnPeer"

if [ -z "$RETRY_NUM" ] ; then
	RETRY_NUM=0
	export RETRY_NUM
fi

study=""
reference=""
hostID=""
INV_PARAM=""
PASS_PARAMS=""

while getopts 's:r:H:' OPT; do
	case $OPT in
	H) hostID="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -H \"$OPTARG\"" ;;
	s) study="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -s \"$OPTARG\"" ;;
	r) reference="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -r \"$OPTARG\"" ;;
	*) INV_PARAM="Invalid_Parameter:$OPT" ;;
	esac
done


# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi

# override getPeer_() of nettask.shi
getPeer_()
{
	echo "$hostID"
}


#
# Override default run_ method
#
run_()
{
	[ -n "$INV_PARAM" ] && return 0
	[ -z "$study" ] && return 0
	[ -z "$hostID" ] && return 0
	[ -z "$reference" ] && return 0

	$TASKD_HOME/runjavacmd -c "0 qr.ClearArchiveRefOnPeer $PASS_PARAMS" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
}

print_()
{
	$TASKD_HOME/runjavacmd -c "print qr.ClearArchiveRefOnPeer $PASS_PARAMS" -p "$JAVA_SERVER_PORT"
}
